import { CoreContext } from '@segment/analytics-core';
export interface PublisherProps {
    host?: string;
    path?: string;
    maxWaitTimeInMs: number;
    maxEventsInBatch: number;
    maxAttempts: number;
    writeKey: string;
}
/**
 * The Publisher is responsible for batching events and sending them to the Segment API.
 */
export declare class Publisher {
    private pendingFlushTimeout?;
    private batch?;
    private _maxWaitTimeInMs;
    private _maxEventsInBatch;
    private _maxAttempts;
    private _auth;
    private _url;
    constructor({ host, path, maxAttempts, maxEventsInBatch, maxWaitTimeInMs, writeKey, }: PublisherProps);
    private createBatch;
    private clearBatch;
    /**
     * Enqueues the context for future delivery.
     * @param ctx - Context containing a Segment event.
     * @returns a promise that resolves with the context after the event has been delivered.
     */
    enqueue(ctx: CoreContext): Promise<CoreContext>;
    private send;
}
//# sourceMappingURL=publisher.d.ts.map